#!/usr/bin/perl
################################################################################
## useful tool to set a waypoint every x meters in a track                    ##
##                                                                            ##
## Written in 2011 by Klaus Engelbertz / http://www.reisenetzwerk.net         ##
## Released under the rights of Creative Commons Licence                      ##
################################################################################

$Datei = "c:\garmin\Radtour.gpx";
$ppDist= 10000; # Distance in meters (10000 = 10km)

$Lat1 = 0;
$Lat2 = 0;
$Lon1 = 0;
$Lon2 = 0;
$Dist = 0;
$nam = 1;
open RD, '<$Datei';
while (<RD>)
{
  if ($_ =~ /<trkpt lat=\"(.+?)\" lon=\"(.+?)\"/)
  {
    $Lat2 = $1;
    $Lon2 = $2;
    if ($Lat1 > 0)
    {
      $Dist += Distanz($Lat1,$Lat2,$Lon1,$Lon2);
      if ($Dist > $ppDist)
      {
        print "N$Lat2 E$Lon2\n";
        $Dist = 0;
        $nam ++;
      }
    }
    $Lat1 = $Lat2;
    $Lon1 = $Lon2;
  }
}
  
# Gibt die Distanz zweier Geokoordinaten in Metern zurck
sub Distanz ()
{
  my ($Lat1, $Lat2, $Lon1, $Lon2) = @_;    
  if ($Lat1 < $Lat2) 
  {
  		$temp = $Lat1;
  		$Lat1 = $Lat2;
  		$Lat2 = $temp;
  }
  if ($Lon1 < $Lon2) 
  {
  		$temp = $Lon1;
  		$Lon1 = $Lon2;
  		$Lon2 = $temp;
  }
  	
  $lat = ($Lat1 + $Lat2) / 2 * 0.01745; 
  $dx = 111.3 * cos($lat) * ($Lon1 - $Lon2);
  $dy = 111.3 * ($Lat1 - $Lat2);
  $distance = sqrt($dx * $dx + $dy * $dy);
  $distance = sprintf("%d",$distance * 1000);
  return $distance;
}
